--
--  GEN_CLK.vhd
--
--  GENERATOR of CLOCK.
--
--        Copyright (C)2001 SEILEBOST
--                   All rights reserved.
--
-- $Id: GEN_CLK.vhd, v0.4 2001/11/21 00:00:00 SEILEBOST $
--
-- Generate several CLK 
-- CLK_CORE : for the core (not used),
-- CLK_16   : for the tone generator,

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity GEN_CLK is
    Port ( CLK      : in  std_logic;
           RST      : in  std_logic;
           CLK_CORE : out std_logic;
           CLK_16   : out std_logic
          );
end GEN_CLK;

architecture Behavioral of GEN_CLK is

SIGNAL COUNT : std_logic_vector(7 downto 0);
begin

 PROCESS(CLK, RST)
 BEGIN
      if (RST = '1') then
         COUNT  <= "00000000";
      elsif (CLK'event and CLK = '1') then
            COUNT      <= COUNT + 1;
            CLK_CORE   <= COUNT(3);
            CLK_16     <= COUNT(7);
      end if;
 END PROCESS;
end Behavioral;
